## snek 1.12

=== test/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT=..

include $(SNEK_ROOT)/snek.defs

PYTHON3?=python3
SNEK_NATIVE?=$(SNEK_PORTS)/posix/snek
SNEK_RISCV?=$(SNEK_PORTS)/qemu-riscv/snek-riscv
SNEK_ARM?=$(SNEK_PORTS)/qemu-arm/snek-arm

LANGS=python3 $(SNEK_NATIVE) $(SNEK_ARM) $(SNEK_RISCV)

SUCCESS_TESTS = \
	pass-andor.py \
	pass-list.py \
	pass-dict.py \
	pass-equal_is.py \
	pass-float.py \
	pass-for-array.py \
	pass-for-range.py \
	pass-for-string.py \
	pass-for-break.py \
	pass-for-nested.py \
	pass-global.py \
	pass-if.py \
	pass-int.py \
	pass-math.py \
	pass-nan.py \
	pass-op.py \
	pass-random.py \
	pass-range.py \
	pass-slice.py \
	pass-while.py \
	pass-while-break.py \
	pass-while-else.py \
	pass-scoping-global.py \
	pass-scoping-local.py \
	pass-none.py \
	pass-args.py \
	pass-assert-success.py \
	pass-interpolate-list.py \
	pass-get.py \
	pass-interpolate-str.py \
	pass-trailing-comma.py \
	pass-chain-op.py \
	pass-precedence.py \
	pass-str.py \
	pass-str-op.py

SYNTAX_TESTS = \
	fail-syntax-lex-bang.py \
	fail-syntax-list-named.py \
	fail-syntax-tuple-named.py

FAIL_TESTS = \
	fail-scoping-no-decl.py \
	fail-range-named.py \
	fail-formal-named-first.py \
	fail-actual-named-first.py \
	fail-args-missing.py \
	fail-arg-dup1.py \
	fail-arg-dup2.py \
	fail-arg-unknown.py \
	fail-assert-fail.py \
	fail-interpolate-missing.py \
	fail-interpolate-extra.py \
	fail-interpolate-badformat.py \
	fail-dictionary-mutable.py \
	$(SYNTAX_TESTS)

check:
	@exit=0; \
	for TEST in $(SUCCESS_TESTS); do \
		echo "Running test $$TEST."; \
		for lang in $(LANGS); do \
			baselang=`basename $$lang`; \
			if $$lang $$TEST; then \
				echo "    pass $$baselang"; \
			else \
				echo "    ***************** $$baselang fail *********************"; \
				exit=1;\
			fi; \
		done; \
	done; \
	for TEST in $(FAIL_TESTS); do \
		echo "Running test $$TEST."; \
		for lang in $(LANGS); do \
			baselang=`basename $$lang`; \
			$$lang $$TEST >/dev/null 2>&1; \
			if [ $$? -eq 1 ]; then \
				echo "    pass $$baselang"; \
			else \
				echo "    ***************** $$baselang fail *********************"; \
				exit=1;\
			fi; \
		done; \
	done; \
	exit $$exit

=== chips/avr/Makefile ===
strfromg-test: strfromg.c ftoa_engine.c strfromg-test.c
	gcc -DSTRFROMG_TEST -O2 -o $@ -g strfromg.c strfromg-test.c ftoa_engine.c

clean:
	rm -f strfromg-test

=== hosts/windows/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT=../..

SNEK_LOCAL_SRC = \
	snek-windows.c \
	snek-math.c \
	snek-random.c \
	snek-input.c

SNEK_LOCAL_INC = snek-windows.h
SNEK_LOCAL_BUILTINS = \
	snek-windows.builtin \
	snek-math.builtin \
	snek-random.builtin \
	snek-input.builtin

INF=altusmetrum.inf
WINDOWS_FILES=snek.exe snek.ico snekde.py $(PDF) $(SNEK_ROOT)/examples $(SNEK_ROOT)/COPYING $(FIRMWARE) $(USBFIRMWARE) $(INF)

include $(SNEK_ROOT)/snek-install.defs

WINDOWS_INSTALL=build/nsis/snek-windows-$(SNEK_VERSION_DASH).exe

CC=i686-w64-mingw32-gcc
MINGFLAGS=-Wall -Wextra -mconsole

OPT=-O0

CFLAGS=$(OPT) -g -I. $(SNEK_CFLAGS) $(MINGFLAGS)

LIBS=-lm

all: $(WINDOWS_INSTALL)

$(WINDOWS_INSTALL): $(WINDOWS_FILES) snek.cfg
	pynsist snek.cfg

snek.cfg: snek.cfg.in $(SNEK_ROOT)/snek-install.defs $(SNEK_ROOT)/snek.defs
	for i in $(FIRMWARE); do echo "	$$i"; done | sed '/@SNEK_FIRMWARE@/r /dev/stdin' snek.cfg.in | sed '/@SNEK_FIRMWARE/d' | $(SNEK_SED) > $@

snek.exe: $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $(SNEK_OBJ) $(LIBS)

vpath %.svg $(SNEK_ROOT)

snekde.py: $(SNEK_ROOT)/snekde/snekde.py
	cp $^ $@

.SUFFIXES: .svg .build .icns .ico .rc .o .exe

.svg.build:
	for i in $(RES); do rsvg-convert -w $$i -h $$i -o $*-$$i.png $^ || exit 1; done && touch $@

.build.ico:
	icotool -c -o $@ $(shell for i in $(RES); do echo $*-$$i.png; done)

.ico.rc:
	./make-rc "$*" $(VERSION) > $@

RES=16 24 32 48 64 72 96 128 180 256

install:
	echo install done

install-otheros: $(WINDOWS_INSTALL)
	cp $(WINDOWS_INSTALL) $(DESTDIR)$(PREFIX)

upload: $(WINDOWS_INSTALL)
	rsync -avz $(WINDOWS_INSTALL) $(SNEKDIST)

clean::
	rm -f snek.exe snek.ico snekde.py snek.cfg snek-*.png
	rm -rf build

=== hosts/zip/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT=../..

SNEK_NO_BUILD_TARGETS = 1

include $(SNEK_ROOT)/snek-install.defs

ZIP_DIST=snek-$(SNEK_VERSION).zip

PROGS= \
	$(SNEK_ROOT)/snekde/snekde

EXAMPLES=$(SNEK_ROOT)/examples

ICONS=$(SNEK_ROOT)/snek.svg

DOC= \
	$(PDF) \
	$(SNEK_ROOT)/COPYING

ZIP_FILES=$(PROGS) $(FIRMWARE) $(USBFIRMWARE) $(ICONS) $(DOC) $(EXAMPLES)

all: $(ZIP_DIST)

$(ZIP_DIST): $(ZIP_FILES)
	-rm -f $@
	-rm -rf zip
	mkdir -p zip/snek
	cp -a $(ZIP_FILES) zip/snek
	cd zip && zip ../$@ -r snek

install:
	echo install done

install-otheros: $(ZIP_DIST)
	cp $(ZIP_DIST) $(DESTDIR)$(PREFIX)

upload: $(ZIP_DIST)
	rsync -avz $(ZIP_DIST) $(SNEKDIST)

clean:
	rm -f snek-*.zip
	rm -rf zip

=== ports/duemilanove/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

vpath %.in ../duemilanove

SNEK_ROOT = ../..
SNEK_ATMEGA = $(SNEK_ROOT)/chips/atmega
BOARD?=duemilanove
CBOARD?=Duemilanove
UBOARD?=DUEMILANOVE
PORT?=/dev/ttyUSB0
CLOCK?=16000000
BAUD?=115200
INSTALLER?=1
ATMEGA_FLASH_SIZE?=0x7e00	# reserve 512 bytes for the boot loader
ATMEGA_RAM_SIZE=0x740		# reserve 192 bytes for the stack
MCU?=atmega328p
SNEK_GLOBAL_ALIAS?=n

include $(SNEK_ATMEGA)/snek-atmega.defs

SNEK_LOCAL_VPATH = $(SNEK_ATMEGA)

SNEK_LOCAL_SRC = \
	snek-pow.c \
	snek-328p.c \
	$(SNEK_ATMEGA_SRC_EXTRA) \
	$(SNEK_ATMEGA_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_ATMEGA_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_ATMEGA_BUILTINS) \
	$(SNEK_ATMEGA_BUILTINS_EXTRA) \
	snek-tone.builtin \
	snek-328p.builtin

include $(SNEK_ROOT)/snek-install.defs

SNEK_ATMEGA_SED=$(SNEK_SED) \
	-e 's;@BOARD@;$(BOARD);g' \
	-e 's;@UBOARD@;$(UBOARD);g' \
	-e 's;@CBOARD@;$(CBOARD);g' \
	-e 's;@BAUD@;$(BAUD);g' \
	-e 's;@PORT@;$(PORT);g' \
	-e 's;@MCU@;$(MCU);g'

SNEK_ATMEGA_BOARD_SED = sed \
	-e 's;@SNEKLIB@;$(SNEKLIB);' \
	-e 's/@SNEK_VERSION@/$(SNEK_VERSION)/' \
	-e 's/@SNEK_VERSION_DASH@/$(SNEK_VERSION_DASH)/' \
	-e 's;@SNEK_ROOT@;$(SNEK_ROOT);' \
	-e 's/@SNEK_DATE@/$(SNEK_DATE)/' \
	-e 's;@BOARD@;$(BOARD);g' \
	-e 's;@UBOARD@;$(UBOARD);g' \
	-e 's;@CBOARD@;$(CBOARD);g' \
	-e 's;@BAUD@;$(BAUD);g' \
	-e 's;@PORT@;$(PORT);g' \
	-e 's;@MCU@;$(MCU);g'

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS)

BASE=snek-$(BOARD)-$(SNEK_VERSION)
ELF=$(BASE).elf
HEX=$(BASE).hex
MAP=$(BASE).map
CC=avr-gcc

CFLAGS=-DUART_BAUD=$(BAUD) -DF_CPU=$(CLOCK)UL -mmcu=atmega328p -I. -I$(SNEK_LOCAL_VPATH) $(SNEK_CFLAGS) $(OPT) -g -Waddr-space-convert
LDFLAGS=$(SNEK_LDFLAGS) \
	-lm \
	-Wl,--defsym -Wl,__TEXT_REGION_LENGTH__=$(ATMEGA_FLASH_SIZE) \
	-Wl,-Map=$(MAP)

all:: $(HEX)

$(HEX): $(ELF)
	avr-objcopy -O ihex -R .eeprom $^ $@

$(ELF): $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
	@gawk '/__data_load_end/{printf("$(BASE) ROM: %d bytes\n", strtonum($$1)); }' $(MAP)

ifeq ($(INSTALLER),1)
all:: snek-$(BOARD)-install snek-$(BOARD)-install.in snek-$(BOARD)-install.1

snek-$(BOARD)-install: snek-atmega328-install.in
	$(SNEK_ATMEGA_SED) $^ > $@
	chmod +x $@

snek-$(BOARD)-install.in: snek-atmega328-install.in
	if [ $@ != $^ ]; then $(SNEK_ATMEGA_BOARD_SED) $^ > $@; fi

load: $(HEX) snek-$(BOARD)-install
	./snek-$(BOARD)-install -hex $(HEX)

snek-$(BOARD)-install.1: snek-duemilanove-install.1.in
	$(SNEK_ATMEGA_SED) $^ > $@

install: snek-$(BOARD)-install $(HEX) snek-$(BOARD)-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-$(BOARD)-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-$(BOARD)-install.1 $(DESTDIR)$(MANDIR)/man1

endif

clean::
	rm -f *.elf *.hex *.map snek-$(BOARD)-install snek-$(BOARD)-install.in snek-$(BOARD)-install.1

=== ports/esp32/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
include ../../snek-install.defs

ESP32_IDF ?= ./esp32-idf

TARGET=snek-esp32-$(SNEK_VERSION).bin
TARGET_DASH=snek-esp32-$(SNEK_VERSION_DASH).bin

all: $(TARGET)

$(TARGET): build/$(TARGET_DASH)
	cp $^ $@

build/$(TARGET_DASH):
	make -C main all
	SNEK_VERSION_DASH=$(SNEK_VERSION_DASH) $(ESP32_IDF) build

clean::
	rm -f $(TARGET)
	$(ESP32_IDF) clean
	+make -C main clean
	rm -rf build

load:
	$(ESP32_IDF) -p /dev/ttyUSB1 flash

connect:
	minicom -D /dev/ttyUSB1 -b 115200

install: $(TARGET)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(TARGET) $(DESTDIR)$(SHAREDIR)

=== ports/ev3/Makefile ===
#
# Copyright © 2020 Mikhail Gusarov <dottedmag@dottedmag.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

vpath snek-posix.c ../posix

SNEK_ROOT=../..

CC=arm-linux-gnueabi-gcc
PROGNAME=snek-ev3
PROG=$(PROGNAME)-$(SNEK_VERSION)
SERVER=snekserver-$(SNEK_VERSION)

SNEK_LOCAL_SRC = \
	snek-main.c \
	snek-posix.c \
	snek-math.c \
	snek-random.c \
	snek-input.c \
	snek-io.c \
	sensors.c \
	motors.c \
	utils.c

SNEK_LOCAL_INC = snek-ev3.h utils.h sensors.h motors.h
SNEK_LOCAL_CFLAGS = -DSNEK_USE_GLIBC_2_4_MATH
SNEK_LOCAL_BUILTINS = \
	snek-ev3.builtin \
	snek-math.builtin \
	snek-random.builtin \
	snek-eeprom.builtin \
	snek-input.builtin

include $(SNEK_ROOT)/snek-install.defs

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS)

OPT?=-O3

SNEK_CFLAGS+=-ffile-prefix-map=/home/keithp/src/snek=. -fstack-protector-strong \
	-fstack-clash-protection -Wformat -Werror=format-security

CFLAGS=-DSNEK_MEM_INCLUDE_NAME $(OPT) -g -I. $(SNEK_CFLAGS) -Werror $(CPPFLAGS)

LIBS=-lm

all: $(PROG) $(SERVER)

$(PROG): $(SNEK_OBJ)
	$(call quiet,CC) $(CFLAGS) $(LDFLAGS) -o $@ $(SNEK_OBJ) $(LIBS)

SERVER_OBJ=snekserver.o utils.o

$(SERVER): $(SERVER_OBJ)
	$(call quiet,CC) $(CFLAGS) $(LDFLAGS) -o $@ $(SERVER_OBJ)

$(SERVER_OBJ): $(SNEK_INC)

install: $(PROG)
	install -d $(DESTDIR)$(SHAREDIR)
	install $(PROG) $(DESTDIR)$(SHAREDIR)

clean::
	rm -f $(PROG) $(SERVER) snekserver.o

=== ports/feather/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

SNEK_SAMD21 = $(SNEK_ROOT)/chips/samd21

PROGNAME=snek-feather
PRODUCT_NAME=SnekFeather
IDPRODUCT=0x8022
IDVENDOR=0x239A

include $(SNEK_SAMD21)/snek-samd21.defs

SNEK_LOCAL_SRC = \
	$(SNEK_SAMD21_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_SAMD21_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_SAMD21_BUILTINS) \
	snek-feather.builtin

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(SRC:.c=.o)

all: $(ELF) $(BIN) $(UF2)

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(OBJ): $(SNEK_INC)

distclean:	clean

clean::
	rm -f *.o *.elf *.bin *.uf2 *.map ao-product.h

install: $(UF2)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(UF2) $(DESTDIR)$(SHAREDIR)

uninstall:

=== ports/grove/Makefile ===
#
# Copyright © 2020 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_ATMEGA = $(SNEK_ROOT)/chips/atmega
SNEK_NO_DICT = 1
#SNEK_NO_SLICE = 1

include $(SNEK_ATMEGA)/snek-atmega.defs

SNEK_LOCAL_VPATH = $(SNEK_ATMEGA)

SNEK_LOCAL_SRC = \
	snek-pow.c \
	snek-328p.c \
	snek-atmega-i2c.c \
	snek-ssd1315.c \
	snek-lis3dh.c \
	$(SNEK_ATMEGA_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_ATMEGA_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_ATMEGA_BUILTINS) \
	snek-grove.builtin \
	snek-328p.builtin \
	snek-draw.builtin

include $(SNEK_ROOT)/snek-install.defs

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS) -DUART_BAUD=115200

BASE=snek-grove-$(SNEK_VERSION)
ELF=$(BASE).elf
HEX=$(BASE).hex
MAP=$(BASE).map
CC=avr-gcc

CFLAGS=-DF_CPU=16000000UL -mmcu=atmega328p -I. -I$(SNEK_LOCAL_VPATH) -g $(SNEK_CFLAGS) $(OPT) -Waddr-space-convert
LDFLAGS=$(SNEK_LDFLAGS) \
	-lm \
	-Wl,--defsym -Wl,__TEXT_REGION_LENGTH__=0x7e00 \
	-Wl,-Map=$(MAP)

all: $(HEX) snek-grove-install

$(HEX): $(ELF)
	avr-objcopy -O ihex -R .eeprom $^ $@

$(ELF): $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
	@gawk '/__data_load_end/{printf("$(BASE) ROM: %d bytes\n", strtonum($$1)); }' $(MAP)

snek-grove-install: snek-grove-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

load: $(HEX) snek-grove-install
	./snek-grove-install -hex $(HEX)

install: snek-grove-install $(HEX) snek-grove-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-grove-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-grove-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f snek*.elf snek*.hex snek*.map snek-grove-install

=== ports/hifive1revb/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

PROGNAME=snek-hifive1revb
PRODUCT_NAME=snek-hifive1revb

# Note -- must set FREEDOM_METAL before building

FREEDOM_METAL ?= /must/set/FREEDOM_METAL

FREEDOM_METAL_PICO = $(FREEDOM_METAL)/pico
FREEDOM_METAL_GLOSS = $(FREEDOM_METAL)/gloss
LD_SCRIPT = metal.default.lds
FREEDOM_METAL_SRC = $(FREEDOM_METAL)/src
FREEDOM_METAL_DRIVERS = $(FREEDOM_METAL_SRC)/drivers
FREEDOM_METAL_INC = $(FREEDOM_METAL)

SNEK_LOCAL_VPATH = $(SNEK_FE310):$(SNEK_AO):$(FREEDOM_METAL_SRC):$(FREEDOM_METAL_DRIVERS):$(FREEDOM_METAL_PICO):$(FREEDOM_METAL_GLOSS)

PICOLIBC_PRINTF_CFLAGS = -DPICOLIBC_FLOAT_PRINTF_SCANF

PICOLIBC_CFLAGS= \
	-specs=picolibc.specs \
	-ffunction-sections \
	-fdata-sections \
	$(PICOLIBC_PRINTF_CFLAGS)

OPT=-Os -g

WARN_FLAGS=-Wall -Wextra -Wcast-align \
	-Wpointer-arith \
	-Wstrict-prototypes \
	-Wmissing-prototypes \
	-Wmissing-declarations \
	-Wnested-externs \
	-Wshadow \
	-Warray-bounds=2\
	-Wno-missing-prototypes\
	-Wno-unused-parameter\
	-Wno-strict-prototypes\
	-Wno-missing-declarations\
	-Wno-cast-align\
	-Wno-maybe-uninitialized

AO_CFLAGS=\
	-std=c18 $(WARN_FLAGS) $(OPT) -g

HIFIVE1REVB_CFLAGS=-march=rv32imac -mabi=ilp32 \
	-I. -I$(SNEK_ROOT) -I$(FREEDOM_METAL_INC) $(PICOLIBC_CFLAGS)

CFLAGS = $(HIFIVE1REVB_CFLAGS) $(SNEK_CFLAGS) $(AO_CFLAGS)

LDFLAGS=$(SNEK_LDFLAGS) $(CFLAGS) -n

LIBS=-lm

ARCH=riscv64-unknown-elf
CC=$(ARCH)-gcc
OBJCOPY=$(ARCH)-objcopy

PROG=$(PROGNAME)-$(SNEK_VERSION).elf
HEX=$(PROGNAME)-$(SNEK_VERSION).hex
MAP=$(PROGNAME)-$(SNEK_VERSION).map

.SUFFIXES: .elf .bin

.elf.bin:
	$(OBJCOPY) -O binary -S $^ $@

SNEK_LOCAL_SRC = \
	vector.S \
	entry.S \
	init.c \
	inline.c \
	fixed-clock.c \
	riscv_plic0.c \
	riscv_clint0.c \
	riscv_cpu.c \
	sifive_fe310-g000_prci.c \
	sifive_fe310-g000_hfrosc.c \
	sifive_fe310-g000_hfxosc.c \
	sifive_fe310-g000_lfrosc.c \
	sifive_fe310-g000_pll.c \
	sifive_uart0.c \
	sifive_spi0.c \
	sifive_gpio-leds.c \
	sifive_wdog0.c \
	sifive_rtc0.c \
	sifive_gpio0.c \
	sifive_i2c0.c \
	i2c.c \
	sifive_local-external-interrupts0.c \
	sys_exit.c \
	button.c \
	cache.c \
	clock.c \
	cpu.c \
	gpio.c \
	interrupt.c \
	led.c \
	lock.c \
	memory.c \
	pmp.c \
	privilege.c \
	rtc.c \
	shutdown.c \
	spi.c \
	switch.c \
	synchronize_harts.c \
	time.c \
	timer.c \
	trap.S \
	uart.c \
	watchdog.c \
	snek-metal.c \
	snek-math.c \
	snek-random.c \
	snek-io.c \
	snek-input.c \
	snek-metal-gpio.c \
	snek-metal-uart.c \
	snek-metal-builtin.c

SNEK_LOCAL_INC = \
	$(SNEK_FE310_INC)

SNEK_LOCAL_BUILTINS = \
	snek-math.builtin \
	snek-random.builtin \
	snek-gpio.builtin \
	snek-input.builtin \
	snek-hifive1revb.builtin

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(patsubst %.S,%.o,$(patsubst %.c,%.o,$(SRC)))

echo::
	echo $(OBJ)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -T$(LD_SCRIPT) -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(HEX): $(PROG)
	$(OBJCOPY) -O ihex -S $^ $@

$(OBJ): $(SNEK_INC) $(FREEDOM_METAL)

distclean:	clean

clean::
	rm -f *.o $(PROGNAME)*.elf $(PROGNAME)*.hex $(PROGNAME)*.map ao-product.h
	rm -f snek-board-install

snek-board-install: snek-board-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

echo::
	echo PROG is $(PROG)

install: $(PROG)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(PROG) $(DESTDIR)$(SHAREDIR)

uninstall:

$(FREEDOM_METAL):
	if [ ! -d $@ ]; then \
		echo "Need to set FREEDOM_METAL before building snek-hifive1revb";\
		exit 1;\
	fi

=== ports/itsybitsy5v/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_AVR = $(SNEK_ROOT)/chips/avr

BUILD_INSTALL?=1
PROGNAME?=snek-itsybitsy5v
UBANAME=$(shell echo $(PROGNAME) | sed 's/snek/ubaboot/')
PRODUCT_NAME?=SnekItsyBitsy5v

AVR_CLOCK?=16000000UL

include $(SNEK_AVR)/snek-avr.defs

SNEK_LOCAL_SRC = \
	$(SNEK_AVR_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_AVR_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_AVR_BUILTINS) \
	../itsybitsy5v/snek-itsybitsy5v.builtin

include $(SNEK_ROOT)/snek-install.defs

ifeq ($(BUILD_INSTALL),1)
INSTALLER=snek-atmega32u4-install
else
INSTALLER=
endif

all: $(ELF) $(HEX) $(INSTALLER)

$(PROG): Makefile $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $(SNEK_OBJ) $(LDFLAGS)
	@gawk '/__data_load_end/{printf("$(BASE) ROM: %d bytes\n", strtonum($$1)); }' $(MAP)

install:: $(HEX)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)

ifeq ($(BUILD_INSTALL),1)
snek-atmega32u4-install: ../itsybitsy5v/snek-atmega32u4-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

install:: snek-atmega32u4-install snek-atmega32u4-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-atmega32u4-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-atmega32u4-install.1 $(DESTDIR)$(MANDIR)/man1
endif

clean::
	rm -f *.hex *.elf *.map
	rm -f ao-product.h $(INSTALLER)

uninstall::

ISP=usbtiny

UBAHEX=../../ubaboot/$(UBANAME).hex
UBABOOT=../../ubaboot/ubaboot.py

load: all $(UBABOOT)
	../itsybitsy5v/snek-atmega32u4-install -hex $(HEX) -ubaboot $(UBABOOT) load

fuseboot: $(UBAHEX) $(UBABOOT)
	../itsybitsy5v/snek-atmega32u4-install -isp $(ISP) -ubahex $(UBAHEX) fuseboot

=== ports/lilypad/Makefile ===
#
# Copyright © 2020 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

BOARD=lilypad
CBOARD=LilyPad
UBOARD=LILYPAD
PORT=/dev/ttyUSB0
BAUD=57600
CLOCK=8000000

include ../duemilanove/Makefile

=== debian/changelog ===
snek (1.12-1) unstable; urgency=medium

  * New upstream

  * Picolibc 1.8.10 compatibility. Closes: #1104364.

 -- Keith Packard <keithp@keithp.com>  Tue, 29 Apr 2025 20:38:16 -0700

=== debian/control ===
Source: snek
Section: interpreters
Priority: optional
Maintainer: Keith Packard <keithp@keithp.com>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13), libreadline-dev, python3:any, lola, gawk
Build-Depends-Indep: avr-libc, gcc-avr,
 binutils-arm-none-eabi, gcc-arm-none-eabi, picolibc-arm-none-eabi (>= 1.4), qemu-system-arm,
 binutils-riscv64-unknown-elf, gcc-riscv64-unknown-elf, picolibc-riscv64-unknown-elf (>= 1.4),
 qemu-system-riscv32,
 asciidoctor, ruby-asciidoctor-pdf, ruby-coderay
Standards-Version: 4.7.2
Homepage: https://sneklang.org
Vcs-Git: https://sneklang.org/cgit/snek.git
Vcs-Browser: https://sneklang.org/cgit/snek.git

Package: snek
Architecture: all
Suggests: snek-bin
Depends: ${misc:Depends}, python3:any, python3-serial, usbutils
Description: Embedded system programming language
 Snek is a small python-like language designed for embedded
 computers. It can run on systems as small as an Arduino Duemilanove
 board, which is an ATmega 328 processor with 32kB of flash and 2kB of
 ram. This package includes binaries and installation tools for many
 targets along with the snekde integrated development environment.

Package: snek-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, snek
Description: Host binary version of Snek programming language
 Snek is a small python-like language designed for embedded
 computers. It can run on systems as small as an Arduino Duemilanove
 board, which is an ATmega 328 processor with 32kB of flash and 2kB of
 ram. This package provides a host snek binary for playing with the
 language on your host machine.

## snek 1.13

=== doc/Makefile ===
SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT=..

include $(SNEK_ROOT)/snek-install.defs

.SUFFIXES: .adoc .pdf .html

ADOC_FILES=snek.adoc

PDF_FILES=$(ADOC_FILES:.adoc=.pdf)
HTML_FILES=$(ADOC_FILES:.adoc=.html)
CSS_FILES=snek.css coderay-asciidoctor.css
IMAGE_FILES=../snek.svg

all: $(HTML_FILES) $(PDF_FILES) all-lessons

BOOK_FILES=snek-book.pdf snek-cover.pdf snek-book-book.pdf snek-cover-book.pdf

book: $(BOOK_FILES)

LETTER_ATTRIBUTES=--attribute='pdf-theme=snek' 
BOOK_ATTRIBUTES=--attribute='pdf-theme=snek-book' -a optimize
ATTRIBUTES=--attribute="revdate=$(SNEK_DATE)" --attribute="version=$(SNEK_VERSION)"

.adoc.html:
	asciidoctor -v -B$(SNEK_ROOT) $(ATTRIBUTES) -b html5 $*.adoc

.adoc.pdf:
	asciidoctor-pdf -B$(SNEK_ROOT) $(ATTRIBUTES) $(LETTER_ATTRIBUTES) $*.adoc

$(PDF_FILES): snek-theme.yml $(IMAGE_FILES)

DOCFILES=$(PDF_FILES) $(HTML_FILES) $(CSS_FILES) $(IMAGE_FILES)

install: $(DOCFILES) install-lessons
	install -d $(DESTDIR)$(DOCDIR)
	for i in $(DOCFILES); do install --mode=644 "$$i" $(DESTDIR)$(DOCDIR) || exit 1; done

snek-book.pdf: snek.adoc snek-book-theme.yml
	asciidoctor-pdf -o `pwd`/$@ -B$(SNEK_ROOT) $(ATTRIBUTES) $(BOOK_ATTRIBUTES) snek.adoc

snek-book-book.pdf: snek-book.pdf
	pdfbook2 -n --paper=letter snek-book.pdf

snek-cover.pdf: snek-cover.svg
	rsvg-convert -d 72 -p 72 -f pdf -o $@ $^

snek-cover-book.pdf: snek-cover.svg
	rsvg-convert -d 69.05 -p 69.94 -f pdf -o $@ $^

upload: $(DOCFILES) upload-lessons
	rsync -avz $(DOCFILES) fonts $(SNEKDOC)

coderay-asciidoctor.css: $(HTML_FILES)

clean:: clean-lessons
	rm -f $(PDF_FILES) $(HTML_FILES) $(BOOK_FILES) coderay-asciidoctor.css

all-lessons:
	+for i in lessons/lesson-*; do make -C $$i all; done

clean-lessons:
	+for i in lessons/lesson-*; do make -C $$i clean; done

upload-lessons:
	+for i in lessons/lesson-*; do make -C $$i upload; done

install-lessons:
	+for i in lessons/lesson-*; do make -C $$i DESTDIR=$(DESTDIR) DOCDIR=$(DOCDIR) install; done

=== examples/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT = ..

include $(SNEK_ROOT)/snek-install.defs

all:
	echo all done

EXAMPLES = \
	blink.py \
	hanoi.py \
	morse.py \
	snek-bsd.py \
	snek.py \
	track-light.py \
	badshuffle.py \
	goodshuffle.py

install:
	install -d "$(DESTDIR)$(EXAMPLEDIR)"
	for example in $(EXAMPLES); do install -m 0644 "$$example" "$(DESTDIR)$(EXAMPLEDIR)" || exit 1; done

clean:

=== hosts/linux/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT=../..

SNEK_NO_BUILD_TARGETS = 1

include $(SNEK_ROOT)/snek-install.defs

LINUX_DIST=snek-linux-$(SNEK_VERSION).tar.bz2
LINUX_SH=snek-linux-$(SNEK_VERSION).sh
DESKTOP_FILES=$(SNEK_PORTS)/posix/snek.desktop.in $(SNEK_ROOT)/snekde/snekde.desktop.in

PROGS= \
	$(SNEK_PORTS)/posix/snek \
	$(SNEK_ROOT)/snekde/snekde \
	$(SNEK_PORTS)/duemilanove/snek-duemilanove-install.in \
	$(SNEK_PORTS)/itsybitsy5v/snek-atmega32u4-install.in \
	$(SNEK_PORTS)/mega/snek-mega-install.in \
	$(SNEK_PORTS)/uno/snek-uno-install.in

EXAMPLES=$(SNEK_ROOT)/examples

ICONS=$(SNEK_ROOT)/snek.svg

DOC= \
	$(PDF) \
	$(SNEK_ROOT)/snekde/snekde.1 \
	$(SNEK_ROOT)/COPYING \
	$(SNEK_PORTS)/duemilanove/snek-duemilanove-install.1 \
	$(SNEK_PORTS)/itsybitsy5v/snek-atmega32u4-install.1 \
	$(SNEK_PORTS)/mega/snek-mega-install.1 \
	$(SNEK_PORTS)/uno/snek-uno-install.1

LINUX_FILES=$(PROGS) $(DESKTOP_FILES) $(FIRMWARE) $(USBFIRMWARE) $(ICONS) $(DOC) $(EXAMPLES)

all: $(LINUX_SH)

$(LINUX_SH): $(LINUX_DIST) linux-install.sh
	cat linux-install.sh $(LINUX_DIST) > $@
	chmod +x $@

linux-install.sh: linux-install.sh.in
	$(SNEK_SED) $^ > $@

$(LINUX_DIST): $(LINUX_FILES) $(LINUX_EXTRA)
	-rm -f $@
	-rm -rf linux
	mkdir -p linux/Snek
	cp -a $(LINUX_FILES) linux/Snek
	tar cjf $@ -C linux Snek

install:
	echo install done

upload: $(LINUX_SH)
	rsync -avz $(LINUX_SH) $(SNEKDIST)

install-otheros: $(LINUX_SH)
	cp $(LINUX_SH) $(DESTDIR)$(PREFIX)

clean:
	rm -f snek-*.sh *.bz2
	rm -rf linux

=== hosts/windows/Makefile ===
--- 
+++ 
@@ -34,7 +34,7 @@
 
 WINDOWS_INSTALL=build/nsis/snek-windows-$(SNEK_VERSION_DASH).exe
 
-CC=i686-w64-mingw32-gcc
+override CC=i686-w64-mingw32-gcc
 MINGFLAGS=-Wall -Wextra -mconsole
 
 OPT=-O0

=== ports/duemilanove/Makefile ===
--- 
+++ 
@@ -26,7 +26,6 @@
 ATMEGA_FLASH_SIZE?=0x7e00	# reserve 512 bytes for the boot loader
 ATMEGA_RAM_SIZE=0x740		# reserve 192 bytes for the stack
 MCU?=atmega328p
-SNEK_GLOBAL_ALIAS?=n
 
 include $(SNEK_ATMEGA)/snek-atmega.defs
 
@@ -76,7 +75,7 @@
 ELF=$(BASE).elf
 HEX=$(BASE).hex
 MAP=$(BASE).map
-CC=avr-gcc
+override CC=avr-gcc
 
 CFLAGS=-DUART_BAUD=$(BAUD) -DF_CPU=$(CLOCK)UL -mmcu=atmega328p -I. -I$(SNEK_LOCAL_VPATH) $(SNEK_CFLAGS) $(OPT) -g -Waddr-space-convert
 LDFLAGS=$(SNEK_LDFLAGS) \

=== ports/esp32/CMakeLists.txt ===
# The following lines of boilerplate have to be in your project's
# CMakeLists in this exact order for cmake to work correctly
cmake_minimum_required(VERSION 3.5)

include($ENV{IDF_PATH}/tools/cmake/project.cmake)
project(snek-esp32-$ENV{SNEK_VERSION_DASH})

=== ports/ev3/Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 
 SNEK_ROOT=../..
 
-CC=arm-linux-gnueabi-gcc
+override CC=arm-linux-gnueabi-gcc
 PROGNAME=snek-ev3
 PROG=$(PROGNAME)-$(SNEK_VERSION)
 SERVER=snekserver-$(SNEK_VERSION)

=== ports/grove/Makefile ===
--- 
+++ 
@@ -46,7 +46,7 @@
 ELF=$(BASE).elf
 HEX=$(BASE).hex
 MAP=$(BASE).map
-CC=avr-gcc
+override CC=avr-gcc
 
 CFLAGS=-DF_CPU=16000000UL -mmcu=atmega328p -I. -I$(SNEK_LOCAL_VPATH) -g $(SNEK_CFLAGS) $(OPT) -Waddr-space-convert
 LDFLAGS=$(SNEK_LDFLAGS) \

=== ports/hifive1revb/Makefile ===
--- 
+++ 
@@ -68,7 +68,7 @@
 LIBS=-lm
 
 ARCH=riscv64-unknown-elf
-CC=$(ARCH)-gcc
+override CC=$(ARCH)-gcc
 OBJCOPY=$(ARCH)-objcopy
 
 PROG=$(PROGNAME)-$(SNEK_VERSION).elf

=== ports/mega/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_ATMEGA = $(SNEK_ROOT)/chips/atmega

include $(SNEK_ATMEGA)/snek-atmega.defs

SNEK_LOCAL_VPATH = $(SNEK_ATMEGA)

SNEK_LOCAL_SRC = \
	$(SNEK_ATMEGA_SRC) \
	$(SNEK_ATMEGA_MATH_SRC) \
	snek-input.c \
	snek-i2c.c \
	snek-atmega-i2c.c \
	snek-mega.c

SNEK_LOCAL_INC = \
	$(SNEK_ATMEGA_INC) \
	$(SNEK_ATMEGA_MATH_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_ATMEGA_BUILTINS) \
	$(SNEK_ATMEGA_MATH_BUILTINS) \
	snek-input.builtin \
	snek-i2c.builtin \
	snek-mega.builtin

include $(SNEK_ROOT)/snek-install.defs

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS)

BASE=snek-mega-$(SNEK_VERSION)
ELF=$(BASE).elf
HEX=$(BASE).hex
MAP=$(BASE).map
override CC=avr-gcc
CFLAGS=-DF_CPU=16000000UL -mmcu=atmega2560 -I. -I$(SNEK_LOCAL_VPATH) -g $(SNEK_CFLAGS) $(OPT) -Waddr-space-convert
LDFLAGS=$(SNEK_LDFLAGS) \
	-Wl,-uvfprintf -lprintf_flt -lm \
	-Wl,-Map=$(MAP)

PORT=/dev/ttyACM0

all: $(HEX) snek-mega-install

$(HEX): $(ELF)
	avr-objcopy -O ihex -R .eeprom $^ $@

$(ELF): $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
	@gawk '/__data_load_end/{printf("$(BASE) ROM: %d bytes\n", strtonum($$1)); }' $(MAP)

snek-mega-install: snek-mega-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

load: $(HEX) snek-mega-install
	./snek-mega-install -port $(PORT) -hex $(HEX)

install: snek-mega-install $(HEX) $(USBSERIAL_HEX) snek-mega-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-mega-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-mega-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f *.elf snek*.hex *.map snek-mega-install

load-direct: $(HEX)
	avrdude -patmega2560 -cwiring -P/dev/ttyACM0 -b115200 -D -Uflash:w:$(HEX):i

=== ports/nano-every/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_ATMEGA = $(SNEK_ROOT)/chips/atmega
BOARD?=nano-every
CBOARD?=NanoEvery
UBOARD?=NANOEVERY
PORT?=/dev/ttyACM0

SNEK_ATMEGA_STORE_SRC = snek-atmega-flash.c

include $(SNEK_ATMEGA)/snek-atmega.defs

SNEK_LOCAL_VPATH = $(SNEK_ATMEGA)

SNEK_LOCAL_SRC = \
	snek-pow.c \
	snek-nano-every.c \
	$(SNEK_ATMEGA_MATH_SRC) \
	$(SNEK_ATMEGA_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_ATMEGA_INC) \
	$(SNEK_ATMEGA_MATH_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_ATMEGA_BUILTINS) \
	snek-math-small.builtin \
	snek-tone.builtin \
	snek-nano-every.builtin

include $(SNEK_ROOT)/snek-install.defs

ATMEGA_CODE_SIZE=0xb000

SNEK_NANO_EVERY_SED=$(SNEK_SED) \
	-e 's;@BOARD@;$(BOARD);g' \
	-e 's;@UBOARD@;$(UBOARD);g' \
	-e 's;@CBOARD@;$(CBOARD);g' \
	-e 's;@ATMEGA_CODE_SIZE@;$(ATMEGA_CODE_SIZE);g' \
	-e 's;@PORT@;$(PORT);g'

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS)

BASE=snek-$(BOARD)-$(SNEK_VERSION)
ELF=$(BASE).elf
HEX=$(BASE).hex
MAP=$(BASE).map
override CC=avr-gcc

MCU=atmega4809

CFLAGS=-DF_CPU=20000000UL \
	-mmcu=$(MCU) \
	-I. -I$(SNEK_LOCAL_VPATH) -g \
	$(SNEK_CFLAGS) \
	$(OPT) \
	-Waddr-space-convert

LDFLAGS=$(SNEK_LDFLAGS) \
	-lm \
	-Wl,--defsym,__TEXT_REGION_LENGTH__=$(ATMEGA_CODE_SIZE) \
	-Wl,-Map=$(MAP)

all: $(HEX) snek-$(BOARD)-install snek-$(BOARD)-install.1 snek-$(BOARD)-reset-port

$(HEX): $(ELF)
	avr-objcopy -O ihex -R .eeprom $^ $@

$(ELF): $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $(SNEK_OBJ) $(LDFLAGS)
	@gawk '/__data_load_end/{printf("$(BASE) ROM: %d bytes\n", strtonum($$1)); }' $(MAP)

snek-$(BOARD)-install: snek-nano-every-install.in
	$(SNEK_NANO_EVERY_SED) $^ > $@
	chmod +x $@

load: $(HEX) snek-$(BOARD)-install snek-$(BOARD)-reset-port
	./snek-$(BOARD)-install -reset ./snek-$(BOARD)-reset-port -hex $(HEX) load

fuseload: $(HEX) snek-$(BOARD)-install snek-$(BOARD)-reset-port
	./snek-$(BOARD)-install -reset ./snek-$(BOARD)-reset-port -hex $(HEX) fuseload

snek-$(BOARD)-install.1: snek-nano-every-install.1.in
	$(SNEK_NANO_EVERY_SED) $^ > $@

snek-$(BOARD)-reset-port: snek-nano-every-reset-port.c
	gcc -o $@ $^

install: snek-$(BOARD)-install $(HEX) snek-$(BOARD)-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-$(BOARD)-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(SHAREDIR)
	install snek-$(BOARD)-reset-port $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-$(BOARD)-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f *.elf *.hex *.map snek-$(BOARD)-install snek-$(BOARD)-install.1 snek-$(BOARD)-reset-port

=== ports/narrow-1284/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_ATMEGA = $(SNEK_ROOT)/chips/atmega

include $(SNEK_ATMEGA)/snek-atmega.defs

SNEK_LOCAL_VPATH = $(SNEK_ATMEGA)

SNEK_LOCAL_SRC = \
	snek-narrow-1284.c \
	$(SNEK_ATMEGA_SRC) \
	$(SNEK_ATMEGA_MATH_SRC) \
	snek-input.c

SNEK_LOCAL_INC = \
	$(SNEK_ATMEGA_INC) \
	$(SNEK_ATMEGA_MATH_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_ATMEGA_BUILTINS) \
	$(SNEK_ATMEGA_MATH_BUILTINS) \
	snek-math.builtin \
	snek-input.builtin \
	snek-narrow-1284.builtin

include $(SNEK_ROOT)/snek-install.defs

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS)

BASE=snek-narrow-1284-$(SNEK_VERSION)
ELF=$(BASE).elf
HEX=$(BASE).hex
MAP=$(BASE).map
override CC=avr-gcc
CFLAGS=-DF_CPU=16000000UL -mmcu=atmega1284 -I. -I$(SNEK_LOCAL_VPATH) -g -fno-jump-tables $(SNEK_CFLAGS) $(OPT) -Waddr-space-convert
LDFLAGS=$(SNEK_LDFLAGS) \
	-Wl,-uvfprintf -lprintf_flt -lm \
	-Wl,-Map=$(MAP)

PORT=/dev/ttyUSB0

all: $(HEX) snek-narrow-1284-install

$(HEX): $(ELF)
	avr-objcopy -O ihex -R .eeprom $^ $@

$(ELF): $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
	@gawk '/__data_load_end/{printf("$(BASE) ROM: %d bytes\n", strtonum($$1)); }' $(MAP)

snek-narrow-1284-install: snek-narrow-1284-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

load: $(HEX) snek-narrow-1284-install
	./snek-narrow-1284-install -port $(PORT) -hex $(HEX)

install: snek-narrow-1284-install $(HEX) $(USBSERIAL_HEX) snek-narrow-1284-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-narrow-1284-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-narrow-1284-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f *.elf snek*.hex *.map snek-narrow-1284-install

load-direct: $(HEX)
	avrdude -pm1284p -carduino -P$(PORT) -b115200 -D -Uflash:w:$(HEX):i

=== debian/changelog ===
snek (1.13-1) unstable; urgency=medium

  * New upstream

  * Adapt to asciidoctor-pdf repackaging. Closes: #1114390.

  * Support cross building.

 -- Keith Packard <keithp@keithp.com>  Fri, 05 Sep 2025 12:13:58 -0700

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,11 @@
 Maintainer: Keith Packard <keithp@keithp.com>
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13), libreadline-dev, python3:any, lola, gawk
-Build-Depends-Indep: avr-libc, gcc-avr,
+Build-Depends-Indep: avr-libc:native, gcc-avr:native,
  binutils-arm-none-eabi, gcc-arm-none-eabi, picolibc-arm-none-eabi (>= 1.4), qemu-system-arm,
  binutils-riscv64-unknown-elf, gcc-riscv64-unknown-elf, picolibc-riscv64-unknown-elf (>= 1.4),
  qemu-system-riscv32,
- asciidoctor, ruby-asciidoctor-pdf, ruby-coderay
+ asciidoctor, asciidoctor-pdf, ruby-coderay
 Standards-Version: 4.7.2
 Homepage: https://sneklang.org
 Vcs-Git: https://sneklang.org/cgit/snek.git
@@ -16,6 +16,7 @@
 
 Package: snek
 Architecture: all
+Multi-Arch: foreign
 Suggests: snek-bin
 Depends: ${misc:Depends}, python3:any, python3-serial, usbutils
 Description: Embedded system programming language

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export PREFIX=/usr
export CFLAGS_POSIX=$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get LDFLAGS)
export V=1

BUILDDIR = $(shell pwd)

SNEK_MOST_WARNINGS =  \
	-fdebug-prefix-map=$(BUILDDIR)=. \
	-Wall \
	-Wcast-align \
	-Wextra \
	-Wpointer-arith \
	-Wstrict-prototypes \
	-Wmissing-prototypes \
	-Wmissing-declarations \
	-Wnested-externs \
	-Wshadow

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_build-indep:
	dh_auto_build -- "SNEK_MOST_WARNINGS=$(SNEK_MOST_WARNINGS)" SNEK_EV3=0

override_dh_auto_test-indep:
	dh_auto_test -- SNEK_EV3=0

override_dh_auto_install-indep:
	dh_auto_install -- SNEK_EV3=0

override_dh_auto_build-arch:
	dh_auto_build -- -C ports/posix SUBDIRS= FIRMWARE= "SNEK_MOST_WARNINGS=$(SNEK_MOST_WARNINGS)"

override_dh_auto_test-arch:
	dh_auto_test -- -C test FIRMWARE= SNEK_RISCV= SNEK_ARM=

override_dh_auto_install-arch:
	dh_auto_install -- -C ports/posix

=== debian/watch ===
version=4
opts="mode=git, gitmode=full, pgpmode=none" \
https://keithp.com/cgit/snek.git \
refs/tags/([\d\.]+) debian uupdate
